<template>
  <v-col>
    <v-row no-gutters class="fill-height" style="max-height: 500px !important;">
      <!-- Group chat info. -->
      <v-col
        v-if="isDesktop"
        xs="12"
        sm="12"
        md="12"
        lg="12"
        style="border-bottom: 1px solid #333;"
      >
        <v-row>
          <v-col>
            <v-toolbar id="toolbar1" color="elevation-0">
              <span
                v-if="groupChatInfo.title"
                class="subheading font-weight-bold"
                >{{ groupChatInfo.title }}</span
              >
              <v-skeleton-loader
                v-else
                class="mt-10"
                :loading="true"
                transition="fade-transition"
                height="94"
                type="table-cell"
              >
              </v-skeleton-loader>
              <v-divider class="mx-4" vertical></v-divider>

              <v-btn v-if="groupChatInfo.imageUrl" icon>
                <v-avatar size="35">
                  <v-img :src="groupChatInfo.imageUrl"></v-img>
                </v-avatar>
              </v-btn>
              <v-skeleton-loader
                v-else
                class="mt-10"
                :loading="true"
                transition="fade-transition"
                height="94"
                type="avatar"
              >
              </v-skeleton-loader>
              <v-col
                v-if="
                  groupChatInfo &&
                    groupChatInfo.dateItem &&
                    groupChatInfo.dateItem.date
                "
                class="text-right"
              >
                <v-btn text>
                  <i class="far fa-clock mr-2"></i>
                  {{
                    groupChatInfo &&
                      groupChatInfo.dateItem &&
                      groupChatInfo.dateItem.date
                  }}
                  at
                  {{
                    groupChatInfo &&
                      groupChatInfo.dateItem &&
                      groupChatInfo.dateItem.time
                  }}
                </v-btn>
                <v-btn
                  :disabled="!conversationData.videoURL"
                  text
                  @click="openVideoCall(groupChatInfo)"
                >
                  <i class="fas fa-mobile-alt mr-2"></i>
                  {{
                    !conversationData.videoURL
                      ? 'Facilitator has not uploaded zoom url yet'
                      : 'Join video group call'
                  }}
                </v-btn>
              </v-col>
              <div v-else id="right-skeleton">
                <v-skeleton-loader
                  class="mt-10"
                  :loading="true"
                  transition="fade-transition"
                  height="94"
                  type="table-cell"
                />
              </div>
            </v-toolbar>
          </v-col>
        </v-row>
      </v-col>
      <!-- Chat groups display. -->
      <v-col xs="12" md="12" lg="3">
        <v-container>
          <v-row :style="'height:' + getChatHeight + 'px;'">
            <v-col v-if="chatGroups.length === 0" xs="12" md="12">
              <h4 class="text-center">
                No Conversations yet.
              </h4>
            </v-col>
            <v-col xs="12" md="12">
              <v-list
                id="scroll-target"
                :style="
                  windowHeight > 600
                    ? 'height: 550px; max-width: 500px;'
                    : 'height: 390px; max-width: 500px;'
                "
                class="overflow-y-auto"
              >
                <v-list-item-group>
                  <v-list-item
                    v-for="(chatGroup, index) in chatGroups"
                    :key="index"
                    @click="selectConversation(chatGroup)"
                  >
                    <v-list-item-icon>
                      <v-avatar v-if="chatGroup.imageUrl">
                        <v-img :src="chatGroup.imageUrl"></v-img>
                      </v-avatar>
                    </v-list-item-icon>
                    <v-list-item-content class="d-inline-block text-truncate">
                      {{ chatGroup.title }}
                    </v-list-item-content>
                  </v-list-item>
                </v-list-item-group>
              </v-list>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
      <v-col
        v-if="isDesktop"
        xs="12"
        md="9"
        lg="9"
        :style="
          'border-left: 1px solid #cacaca; height: ' + getChatHeight + 'px;'
        "
      >
        <Chat :chat-id="chatId" />
      </v-col>
    </v-row>
  </v-col>
</template>

<script>
import Chat from './Chat'

export default {
  name: 'ChatWrapper',
  components: {
    Chat
  },
  props: {
    groupType: {
      type: String,
      default: 'facilitator'
    }
  },
  data() {
    return {
      loading: false,
      messages: [],
      chatGroups: [],
      chatId: null,
      groupChatInfo: {}
    }
  },
  computed: {
    conversationData() {
      return this.$store.state.conversations.groupChatInfo
    },
    user() {
      return this.$store.state.authentication.user
    },
    getChatHeight() {
      let toolbar = 200
      let winHeight = 0
      this.$nextTick(() => {
        const toolbarElement = document.getElementById('toolbar1')
        toolbar = toolbarElement ? toolbarElement.clientHeight : 0
      })

      winHeight = window.innerHeight - 20
      return winHeight - toolbar
    },
    windowHeight() {
      return window.innerHeight
    },
    isDesktop() {
      return window.innerWidth > 768
    }
  },
  watch: {
    chatId: {
      async handler(chatId) {
        this.$forceUpdate()
        await this.$store.commit('conversations/clearConversations')
        if (chatId) {
          await this.$store.commit('conversations/addGroupChatId', chatId)
          await this.$store
            .dispatch('conversations/getConversation')
            .then(() => {})
            .catch(err => {
              chatId = null
              this.$store.commit('conversations/clearConversations')
              console.log(err)
            })
        }
      }
    }
  },
  mounted() {
    this.disableScroll()

    // chatGroups
    this.$store
      .dispatch('conversations/getConversations')
      .then(res => {
        this.chatGroups = res
      })
      .catch(err => {
        console.log(err)
        this.$router.push('/dashboard')
      })
  },
  destroyed() {
    this.$store.commit('conversations/clearConversations')
    this.enableScroll()
  },
  methods: {
    selectConversation(chatGroup) {
      if (!this.isDesktop) {
        // open in new page
        this.$router.push(`/facilitator/conversation/${chatGroup.groupId}`)
      } else {
        this.chatId = chatGroup.groupId
        this.$store.commit('conversations/setGroupChatInfo', chatGroup)
        this.groupChatInfo = chatGroup
        this.$forceUpdate()
      }
    },
    disableScroll() {
      document.documentElement.style.height = '100%'
      document.documentElement.style.overflow = 'hidden'
    },
    enableScroll() {
      document.documentElement.style.height = ''
      document.documentElement.style.overflow = ''
    },
    openVideoCall(data) {
      if (data.videoType === 'zoom' && data.videoURL !== '') {
        window.open(data.videoURL)
      }
    }
  }
}
</script>

<style lang="scss">
#right-skeleton {
  position: absolute;
  right: 2%;
}
</style>
